module.exports.replace = ( fn, obj ) => {
  var fnCode = fn.toString();
  fnCode = changeValues(fnCode, obj);
  //The func function creates a new function, but then immediately executes it, 
  //whereas the evaluate function simply executes the code on the spot. use IIFE ()
  return (new Function( 'return (' + fnCode + ')' )());
};

module.exports.getHTMLData = (url) => {

};

// used for function replacement
function changeValues( fnCode, obj ) {
  if( arguments.length !== 2 || 
    !obj || 
    (Object.keys(obj).length === 0 && obj.constructor === Object) ) {
	  throw new Error('Invalid parameters for Outline');
  }

  if( fnCode.indexOf('({') === -1 ) {
    throw new Error('outline doesnt contain any replacable parameter.' + 
				' Replacable parameter must be within {}');
  }
  else {
    for(var prop in obj) {
	  fnCode = fnCode.replace('{' + prop + '}', '"' + obj[prop] + '"');
    }
  }

  return fnCode;
};

// Utility function that downloads a URL and invokes
// callback with the data.
function download( url, callback, attr ) {
  var http;
  var result;
  
  if (url.includes("https://")) {
    http = require("https");
  } else {
    http = require("http");
  }  

  http.get(url, function( res ) {
    var data = "";
     
    res.on('data', function ( chunk ) {
      data += chunk;
    });
    res.on("end", function() {
       result = callback(data, attr);
    });
  }).on("error", function() {
    callback(null);
  });

  return result;
}

function createObjectForAttribute( data, att ) {
  var $ = cheerio.load(data);
  var fieldObj = {};
  $('[' + att + ']').each(function(i, e) {
    var prefix = $(e).prop("name");
    var attribute = $(e).attr(att);
    fieldObj[preparePropertyName(prefix, attribute)] = '{css:' + prefix + '[' + att + '="' + attribute + '"]}'; 
  });
  return fieldObj; 
}

function preparePropertyName( prefix, propName ) {
  var result = propName;
  
  switch(prefix) {
    case 'a': 
      result += '_link';  
      break;
    case 'input':
      result += '_text';
      break;
    case 'button': 
      result += '_button';
      break; 
  }

  return result;
}